#include <iostream>
#include <set>
using namespace std;

typedef long long int lli;

struct Point {
    long long int x;
    long long int y;
};

int n;
set<Point> points;

lli distance(Point a, Point b) {
    lli dx = a.x - b.x;
    lli dy = a.y - b.y;
    return dx*dx + dy*dy;
}

bool operator<(const Point& left, const Point& right) {
    if (left.x + left.y == right.x + right.y) {
        return left.y < right.y;
    }
    return left.x + left.y < right.x + right.y;
}

bool hasNext(Point a1, Point a2, Point &a3) {
    a3 = Point{a2.x+a1.y-a2.y, a2.y-a1.x+a2.x};
//    cout << "   checking " << a3.x << " " << a3.y <<endl;
    if (points.find(a3) != points.end())
        return true;

    a3 = Point{a2.x-a1.y+a2.y, a2.y+a1.x-a2.x};
//    cout << "   checking " << a3.x << " " << a3.y <<endl;
    return points.find(a3) != points.end();
}

bool hasSquare(Point a1, Point a2) {
    Point a3;
    if (!hasNext(a1, a2, a3))
        return false;
    Point a4;
    return hasNext(a2, a3, a4);
}

bool getSquare(Point a1, Point a2, Point &a3, Point &a4) {
    if (!hasNext(a1, a2, a3))
        return false;
    return hasNext(a2, a3, a4);
}



int main() {

    cin >> n;

    lli sum = 0;


    for (int i = 0; i < 4 * n; ++i) {
        long long int x;
        cin >> x;
        long long int y;
        cin >> y;
        points.insert({x, y});
    }

    while (points.size()) {
//        cout << "SIZE B " << points.size() <<endl;
        Point cur = *points.begin();

        Point shortest;
        bool found = false;
        bool first = true;
        for (auto other : points) {
            if (first) {
                first = false;
                continue;
            }
            if (!hasSquare(cur, other))
                continue;

            if (!found) {
                shortest = other;
                found = true;
                continue;
            }
            if(distance(cur, shortest) > distance(cur, other)) {
                shortest = other;
            }
        }

        Point p1=cur, p2=shortest, p3, p4;
       getSquare(p1, p2, p3, p4);

        lli d = distance(p1, p2);
        sum += d;

//        cout << "Found square of side" << d <<endl;
//        cout << "   " << p1.x << " " << p1.y <<endl;
//        cout << "   " << p2.x << " " << p2.y <<endl;
//        cout << "   " << p3.x << " " << p3.y <<endl;
//        cout << "   " << p4.x << " " << p4.y <<endl;


        points.erase(p1);
        points.erase(p2);
        points.erase(p3);
        points.erase(p4);
//        cout << "SIZE E " << points.size() <<endl;
    }

    cout << sum <<endl;

    return 0;
}
